###

#

packed_pixel< BitField, ChannelRefs, Layout > Struct Template Reference
ColorBase » Models » packed_pixel | Pixel » Models » packed_pixel | PixelBased » Models

Heterogeneous pixel value whose channel references can be constructed from the pixel bitfield and their index. Models ColorBaseValueConcept, PixelValueConcept, PixelBasedConcept Typical use for this is a model of a packed pixel (like 565 RGB) More...

`#include <packed_pixel.hpp>`

## Public Types

using | layout_t = Layout
using | value_type = packed_pixel< BitField, ChannelRefs, Layout >
using | reference = value_type &
using | const_reference = value_type const &

## Public Member Functions

| packed_pixel (const BitField &bitfield)
template<typename Pixel >
| packed_pixel (Pixel const &p, typename std::enable_if< is_pixel< Pixel >::value >::type *=nullptr)
| packed_pixel (int chan0, int chan1)
| packed_pixel (int chan0, int chan1, int chan2)
| packed_pixel (int chan0, int chan1, int chan2, int chan3)
| packed_pixel (int chan0, int chan1, int chan2, int chan3, int chan4)
template<typename Pixel >
auto | operator= (Pixel const &p) -> packed_pixel &
template<typename Pixel >
bool | operator== (Pixel const &p) const
template<typename Pixel >
bool | operator!= (Pixel const &p) const
auto | operator= (int channel) -> packed_pixel &
bool | operator== (int channel) const

## Public Attributes

BitField | _bitfield {0}

## Static Public Attributes

static constexpr bool | is_mutable

## Detailed Description

template<typename BitField, typename ChannelRefs, typename Layout>
struct boost::gil::packed_pixel< BitField, ChannelRefs, Layout >

Heterogeneous pixel value whose channel references can be constructed from the pixel bitfield and their index. Models ColorBaseValueConcept, PixelValueConcept, PixelBasedConcept Typical use for this is a model of a packed pixel (like 565 RGB)

Template Parameters

  BitField | Type that holds the bits of the pixel. Typically an integral type, like std::uint16_t.
  ChannelRefs | MP11 list whose elements are packed channels. They must be constructible from BitField. GIL uses packed_channel_reference
  Layout | defining the color space and ordering of the channels. Example value: rgb_layout_t

## Member Data Documentation

## is_mutable

constexpr bool is_mutable

static constexpr

Initial value:
=
channel_traits<mp11::mp_front<ChannelRefs>>::is_mutable

The documentation for this struct was generated from the following files:

- metafunctions.hpp
- packed_pixel.hpp